; Hey Emacs, this file is -*- Emacs-lisp -*- 
;
;  Multilingual Terminal Emulator "MuTerminal".
; 
; Copyright (C) 1998,99 Kazuho Okui and Takashi Murai. ALL RIGHT RESERVED
;  
; This file is part of MuTerminal.
;
; MuTerminal is free software; you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation; either version 2, or (at your option)
; any later version.
;
; calc-font-width.el,v 2.0 1999/10/02 15:08:58 kaz Exp
; calc-font-width.el,v: calculation Unicode Font Width
;
;
; This program needed utf8.txt.
;

(defun calc-font-width (buffer)
"Copy to register the text of the region"
(interactive "BBuffer:")
(let ((oldbuf (current-buffer))
      (counter 0)
      (data 0)
      (hex 0))
  (save-excursion
    (set-buffer (get-buffer-create oldbuf))
    (insert-string "0,\n0,\n0,\n0,\n")
    (set-buffer (get-buffer-create buffer))
    (goto-char (point-min))
    (while t
      (set-buffer (get-buffer-create buffer))
      (push-mark)
      (forward-char)
      (copy-region-as-kill (mark) (point))
      (set-buffer (get-buffer-create oldbuf))
      (setq hex (* 2 hex))
      (if (eq 2 (string-width (car kill-ring-yank-pointer)))
	  (setq hex (1+ hex)))
      (setq counter (1+ counter))
      (if (eq 0 (% counter 8))
	  (progn
	   (insert-string (concat hex ",\n"))
	   (setq hex 0)
	   (setq data 0)))
      ))))
